/// <reference types="node" resolution-mode="require"/>
/// <reference types="node" resolution-mode="require"/>
/// <reference types="node" resolution-mode="require"/>
import { Buffer } from 'buffer';
import EventEmitter from 'events';
import { Socket } from 'net';
export interface DebugConnection extends EventEmitter {
    close(): void;
    sendMessage<T = unknown>(message: T): void;
    sendRequest<R = void, T extends object = object>(command: string, args?: T): Promise<R>;
}
export interface DebugEnvelope {
    version: number;
    type: string;
    [key: string]: unknown;
}
export interface DebuggerRequest {
    request_seq: number;
    command: string;
    args: unknown;
}
export interface DebuggeeEvent {
    type: string;
    [key: string]: unknown;
}
export interface DebuggeeResponse extends DebugEnvelope {
    type: 'response';
    request_seq: number;
    error?: string;
    body?: unknown;
}
export declare class QuickJSDebugConnection extends EventEmitter implements DebugConnection {
    socket: Socket;
    requestTimeout: number;
    requestVersion: number;
    requestSeq: number;
    requestReactions: Map<number, {
        resolve: (value: unknown) => void;
        reject: (error?: unknown) => void;
    }>;
    constructor(socket: Socket);
    close(): void;
    sendMessage<T>(message: T): void;
    sendEnvelope(type: string, data: object): void;
    sendRequestRaw(command: string, args?: object): number;
    sendRequest<R = void, T extends object = object>(command: string, args?: T): Promise<R>;
    handleMessage(message: Buffer): void;
}
